31/05/19

lcli: è un semplice client a linea di comando per testare i diversi comandi REST della piattaforma Lambda Service Store/Authentication
Il programma ha il solo compito di aiutare lo sviluppatore nei diversi test di comunicazione e verifica.

*************************************************************
QUESTO PROGRAMMA NON E' INDICATO PER UN'AMBIENTE DI ESERCIZIO
*************************************************************

Usage: lcli [OPTIONS] COMMAND [arg...]

Lambda Service CLI Manager Ver.  0.13 Alfa

Options:          
  -v, --version   Show the version and exit

Commands:         
  register        Register to Lambda Service
  login           Login to Lambda Service
  login_otp       Login to Lambda Service using Q-ID OTP
  license         Get user license details
  files           Get user files details
  totalfiles      Get user files total details
  searchfiles     Search user files details
  upload          Upload file to Lambda Store
  uploadv2        Upload versione 2 file to Lambda Store
  uploadv3        Upload versione 3 file to Lambda Store
  download        Download file from Lambda Service
  documentinfo    Download file info from Lambda Service
  decode          Decode QRCode for Lambda Service

Run 'lcli COMMAND --help' for more information on a command.

lcli crea automaticamente nella stessa cartella in cui si trova un file per le proprio configurazioni: config.ini

Esempio file di configurazione:

[UserData]
User=MARCODEMO
Password=7465737431323334
Token=oqsitcTbFf,1563180469,5d3121293c595bcfb1a5483c88e0ae3485c11136
#ESERCIZIO (ATTUALE CONFIGURAZIONE)
Server=https://services.gt50.org/lambdaclient/
#SANDBOX DI TEST E SVILUPPO
#Server=https://services-clonearuba.gt50.org/lambdaclient/

Lanciando lcli da linea di comando è possibile vedere a quale gateway il client si connetterà:

$./lcli

User data read from config
Connect to: https://services.gt50.org/lambdaclient/

(In questo caso l'accesso è verso il servizio di ESERCIZIO)

Per accedere e ricavare il proprio token di accesso è necessario effettuare il login con il comando "login" o "login_otp".

La sintassi è molto semplice:
Usage: lcli login USER PASSWORD

Login to Lambda Service

Arguments:
  USER         Login to access the service
  PASSWORD     Password to access the service

Per avere informazioni sull'account una volta ricevuto l'OK ed un token di accesso si usi il comando "license":

$ ./lcli license
User data read from config
Connect to: https://services.gt50.org/lambdaclient/
201 Created
{"error":false,"http_code":201,"STATUS":"VALID: 1000:923:1000:619:0:3:20200108090237"}
User license: VALID: 1000:923:1000:619:0:3:20200108090237
Total tokens:  1000
Used tokens: 923
Total space (MB): 1000
Used space (MB): 619
OTP 1 = Yes, 0 = No: 0

Per caricare file sulla piattaforma (La cifratura del file avviene lato client quindi ATTENZIONE) usare invece "upload", "uploadv2" o "uploadv3":

$ ./lcli uploadv3 NetworkBouncyBall.cs.pdf
User data read from config
Connect to: https://services.gt50.org/lambdaclient/
#1 2019-05-31 12:37:34 main.go:778 ▶ INF SHA256 file: F4BFC1BB96B78FAE7D21DB6E463BD0887030E4DBA334B4DB1E7334A6646BA9BC
#2 2019-05-31 12:37:34 main.go:786 ▶ INF FileNameDateTime Upload: 20190531123734
#3 2019-05-31 12:37:34 main.go:811 ▶ INF 201 Created
#4 2019-05-31 12:37:34 main.go:812 ▶ INF {"error":false,"http_code":201,"UPLOAD":"OK"}
#5 2019-05-31 12:37:34 main.go:815 ▶ INF upload finished.

I comandi "download" e "documentinfo" non hanno bisogno di alcun tipo di autenticazione e possonn essere usati con ogni client.

ATTENZIONE: le password NON sono salvate nel file di config come codificate, per l'invio si utilizza comunque il protocollo HTTPS.
La password inoltre sono in chiaro mentre vengono digitate in console.

Per le diverse chiamate REST disponibili si veda il documento:

https://services-aruba.gt50.org/documentation/ListaChiamateRESTServerLambdav1.15.pdf
